﻿using System;
using System.Globalization;
using System.IO;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.Collections.Generic;
 
namespace SDK.Examples
{
	public class SignerOrder
	{
        public static string API_KEY = <YOUR API KEY HERE>;
        public static string API_URL = <ENVIRONMENT URL HERE>;
 
        public static void Main (string[] args)
        {
	    var usCulture = new CultureInfo("en-US");
            var utcDate = DateTime.UtcNow;
            var gmt1Date = TimeZoneInfo.ConvertTimeBySystemTimeZoneId(utcDate, "W. Europe Standard Time");
            var str = gmt1Date.ToString("ddd, dd MMM yyyy HH:mm:ss z", usCulture);
	    EslClient eslClient = new EslClient(API_KEY, API_URL);
	    DocumentPackage documentPackage = PackageBuilder.NewPackageNamed("Policy " + str)
		.WithSigner(SignerBuilder.NewSignerWithEmail("signer1@xyz.com")
			.WithFirstName("FirstNameSigner1")
			.WithLastName("LastNameSigner1")
			.SigningOrder(1))
		.WithSigner(SignerBuilder.NewSignerWithEmail("signer2@xyz.com")
			.WithFirstName("FirstNameSigner2")
			.WithLastName("LastNameSigner2")
			.SigningOrder(2))
		.WithSigner(SignerBuilder.NewSignerWithEmail("signer3@xyz.com")
			.WithFirstName("FirstNameSigner3")
			.WithLastName("LastNameSigner3")
			.SigningOrder(2))
		.WithSigner(SignerBuilder.NewSignerWithEmail("signer4@xyz.com")
			.WithFirstName("FirstNameSigner4")
			.WithLastName("LastNameSigner4")
			.SigningOrder(3))
		.WithDocument(DocumentBuilder.NewDocumentNamed("First Document")
			.FromFile("res/document.pdf")
			.WithSignature(SignatureBuilder.SignatureFor("signer1@xyz.com")
				.OnPage(0)
				.AtPosition(100, 200))
			.WithSignature(SignatureBuilder.SignatureFor("signer2@xyz.com")
				.OnPage(0)
				.AtPosition(100, 400))
			.WithSignature(SignatureBuilder.SignatureFor("signer3@xyz.com")
				.OnPage(0)
				.AtPosition(100, 600))						
			.WithSignature(SignatureBuilder.SignatureFor("signer4@xyz.com")
				.OnPage(0)
				.AtPosition(100, 800)))
		.Build();
 
		// Issue the request to the e-SignLive server to create the DocumentPackage
		PackageId packageId = eslClient.CreatePackage(documentPackage);
 
		// Send the package to be signed by the participants
		eslClient.SendPackage(packageId);
	}
    }
}